<template>
  <div>
    <van-popup
      v-model="postShow"
      class="more-search bg-gray"
      position="right"
      get-container="body"
    >
      <div class="title-layout font-bold font-16">库存拥有者</div>
      <van-search
        v-model="keywords"
        placeholder="商品ID 编号 名称 拼首"
        show-action
        @search="onSearch"
      >
        <i slot="left-icon" class="fa fa-search"></i>
        <div slot="action" class="font14" @click="onSearch">搜索</div>
      </van-search>
      <search-result :result-num="searchNum"></search-result>
      <div class="w100 listHeight" ref="scrollRef">
        <van-pull-refresh
          v-model="isRefreshing"
          @refresh="onRefresh">
          <van-list
            v-model="loading"
            :finished="finished"
            finished-text="没有更多了"
            :error.sync="error"
            :offset="10"
            @load="onLoad">
            <van-radio-group v-model="checked">
              <van-cell-group>
                <van-cell :title="titleInitial(item)" clickable @click="itemClick(item,index)" v-for="(item,index) in postDataList"
                          :key="index">
                  <template #right-icon>
                    <van-radio :name="item.comGoodsId" />
                  </template>
                </van-cell>
              </van-cell-group>
            </van-radio-group>
          </van-list>
        </van-pull-refresh>
      </div>
      <div class="action-bottom">
        <van-button type="default" @click="onCancelClick">取消</van-button>
        <van-button type="info" class="submit" @click="onConfirmClick">确定</van-button>
      </div>
    </van-popup>
  </div>
</template>

<script>
import {getGoodsList} from '../api/common'
import {getResListNum} from '../utils/common'
import SearchResult from './SearchResult'
import { Dialog } from 'vant'

export default {
  name: 'SearchStock',
  components: {SearchResult},
  data() {
    return {
      postShow: false,
      keywords: '',
      isRefreshing: false,
      loading: false,
      finished: false,
      error: false,
      searchNum: '0',
      currentPage: 1,
      pageSize: 10,
      postDataList: [],
      checked: '',
      choosedPost: {}
    }
  },
  computed: {
    linkInfo () {
      return this.$store.state.linkInfo
    }
  },
  props: {
    value: {
      type: Boolean,
      default: false
    },
    customer: {
      type: Object,
      default: () => {}
    }
  },
  watch: {
    value(val) {
      this.postShow = val
      if (val) {
        this.postDataList = []
        this.choosedPost = JSON.parse(JSON.stringify(this.customer))
        this.checked = !this.customer.comGoodsId ? '' : this.customer.comGoodsId
        console.log(this.checked)
        this.currentPage = 1
        this.onLoad()
      }
    },
    postShow (val) {
      if (!val) {
        this.$refs.scrollRef.scrollTop = 0
      }
      this.$emit('input', val)
    }
  },
  methods: {
    /// 标题拼接 <!-- 药厂码/（SAP码）名称 -->
    titleInitial(model) {
      let titleStr = model.comGoodsId + '/(' + model.goodsOpcode + ')' + model.goodsName + '/' + model.goodsDesc + '/' + model.partyName + '/' + model.packageNum + '/' + model.unitName
      // return titleStr
      return '(608)上药控股有限公司'
    },
    onSearch () {
      // if (!this.isJudgeStrNull(this.keywords)) {
      //   Dialog.alert({
      //     title: '温馨提示',
      //     message: '搜索内容为空！'
      //   }).then(() => {
      //   })
      //   return
      // }
      this.keywords = this.keywords.replace(/\s+/g, '')
      this.$refs.scrollRef.scrollTop = 0
      this.currentPage = 1
      this.finished = false
      this.onLoad()
    },
    onCancelClick() {
      this.postShow = false
      this.$emit('cancleclick')
    },
    onConfirmClick() {
      if (!this.choosedPost.comGoodsId) {
        Dialog.alert({
          title: '温馨提示',
          message: '请选择选项！'
        }).then(() => {
        })
        return
      }
      this.postShow = false
      // this.$emit('confirmclick', {
      //   page: 'stock',
      //   value: this.choosedPost
      // })
      this.$emit('confirmclick', {
        page: 'stockOwner',
        value: {
          stockId: 716432,
          name: '(608)上药控股有限公司'
        }
      })
    },
    itemClick(item, index) {
      this.checked = item.comGoodsId
      this.choosedPost = item
    },
    onRefresh() {
      // 刷新接口
      // this.postDataList = []
      this.currentPage = 1
      this.isRefreshing = true
      this.finished = false
      this.getPostData()
    },
    onLoad() {
      this.loading = true
      this.getPostData()
    },
    getPostData() {
      let _this = this
      let data = {
        'goods': _this.keywords,
        'dbName': this.linkInfo.sysDbSource + '-' + this.linkInfo.appRealDb + '-' + this.linkInfo.sysOrgId,
        'saler': this.linkInfo.sysUserId,
        'start': _this.currentPage,
        'length': _this.pageSize
      }
      getGoodsList(data).then(rt => {
        if (_this.currentPage === 1) {
          _this.searchNum = getResListNum(rt.msg)
          this.postDataList = []
        }
        if (rt.code === 1 || rt.code === '1') {
          if (this.isRefreshing) {
            this.postDataList = rt.data
          } else if (!!rt.data || rt.data.length > 0) {
            this.postDataList = this.postDataList.concat(rt.data)
          }
          // _this.postDataListSetAction(rt.data)
          // 重置刷新提示
          _this.isRefreshing = false
          // 重置加载更多提示
          _this.loading = false
          // 若当前加载的页数没有满足每页的数量代表完全加载
          if (rt.data.length < 10) {
            _this.finished = true
          } else {
            // 加载成功后下一页自增1
            _this.currentPage++
          }
        } else {
          _this.$toast(rt.msg)
          // _this.$toast('列表获取失败')
          _this.isRefreshing = false
          _this.error = true
          _this.finished = true
        }
        // 加载状态结束
        _this.loading = false
      }).catch(e => {
        _this.$toast('列表获取失败')
        _this.isRefreshing = false
        _this.loading = false
        _this.error = true
        _this.finished = true
      })
    },
    // 数据处理
    postDataListSetAction(array) {
      array.forEach((res) => {
        this.postDataList.push({
          assigneeFactoryId: res.assigneeFactoryId,
          catagory: res.catagory,
          comGoodsFormId: res.comGoodsFormId,
          comGoodsId: res.comGoodsId,
          comGoodsVarietyId: res.comGoodsVarietyId,
          comUnitId: res.comUnitId,
          defaultExpireDate: res.defaultExpireDate,
          factoryId: res.factoryId,
          goodsDesc: res.goodsDesc,
          goodsName: res.goodsName,
          goodsOpcode: res.goodsOpcode,
          goodsSpell: res.goodsSpell,
          goodsStatus: res.goodsStatus,
          midPacknum: res.midPacknum,
          packageNum: res.packageNum,
          partyName: res.partyName,
          partyName1: res.partyName1,
          partyOpcode: res.partyOpcode,
          productLocation: res.productLocation,
          unitName: res.unitName,
          goodsForm: res.goodsForm,
          partyOpcode1: res.partyOpcode1,
          priceCode: res.priceCode,
          retailPrice: res.retailPrice,
          taxRate: res.taxRate,
          varietyName: res.varietyName
        })
      })
    },
    /// 判断数值是否为空
    isJudgeStrNull(val) {
      if (val !== null && val !== undefined && val !== '') {
        return true
      }
      return false
    }
  }
}
</script>

<style lang="scss" scoped>
  .content {
    background-color: #F5F5F5;
  }
  .more-search {
    width: 75%;
    height: 100%;
    overflow: hidden;
    display: flex;
    flex-direction: column;
  }
  .title-layout {
    height: 45px;
    line-height: 45px;
    text-align: center;
    background: white;
    font-size:17px;
    font-weight:500;
    color: #23262A;
  }

  .listHeight {
    flex: 1;
    overflow-x: hidden;
    overflow-y: auto;
  }

  .num-tip {
    padding: 10px;
  }

  .item-layout {
    height: 40px;
    line-height: 40px;
    background: white;
    border-bottom: #dedede 1px solid;
    padding-left: 10px;
  }

  .action-bottom {
    width: 100%;
    display: flex;
    button {
      flex: 1;
    }
  }

  .red-tips {
    color: #fb1c1c;
    font-weight: bold;
  }
</style>
